use std::num::NonZeroU16;

#[derive(Debug, Clone, Copy, PartialEq, Eq, PartialOrd, Ord)]
#[repr(transparent)]
pub struct Fadetime(pub NonZeroU16);

#[derive(Debug, Clone, Copy, PartialEq, Eq, PartialOrd, Ord)]
#[repr(transparent)]
pub struct Coord(pub i16);

#[derive(Debug, Clone, Copy, PartialEq, Eq, PartialOrd, Ord)]
pub struct Position(pub Coord, pub Coord);

impl Position {
    pub const fn offset(self, Offset(dx, dy): Offset) -> Self {
        Self(Coord(self.0 .0 + dx.0), Coord(self.1 .0 + dy.0))
    }
}

#[derive(Debug, Clone, Copy, PartialEq, Eq, PartialOrd, Ord)]
pub struct Offset(pub Coord, pub Coord);
